## hedgewars 0.9.14.1

=== CMakeLists.txt ===
project(hedgewars)

cmake_minimum_required(VERSION 2.6.0 FATAL_ERROR)
cmake_policy(SET CMP0003 NEW)

IF(POLICY CMP0012)
    cmake_policy(SET CMP0012 NEW)
ENDIF()

#detect subversion revision (if present)
#set(version_suffix "-dev") #UNSET THIS VARIABLE AT RELEASE TIME
IF(version_suffix MATCHES "-dev")
    set(HW_DEV true)
    IF (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.hg)
        FIND_PROGRAM(HGCOMMAND hg)
        IF(HGCOMMAND)
            exec_program(${HGCOMMAND}
                    ARGS identify -in ${CMAKE_CURRENT_SOURCE_DIR}
                    OUTPUT_VARIABLE version_suffix
                    )
            STRING(REGEX REPLACE "(.*) +(.*)" "\\2:\\1" version_suffix ${version_suffix})
            MESSAGE(STATUS "Building revision ${version_suffix}")
            set(version_suffix ".${version_suffix}")
#			#truncate to numbers only - trying to fix a problem described in http://www.hedgewars.org/node/2019
#			STRING(REGEX REPLACE "^\\.(\\d+)" ".\\1" version_suffix ${version_suffix})
#			# screw whole suffix if there's no number
#			STRING(REGEX REPLACE "^\\.([a-z]+.*)" "-dev" version_suffix ${version_suffix})
        ENDIF()
    ENDIF()
ELSE()
    set(HW_DEV false)
ENDIF()

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules)

set(CPACK_PACKAGE_VERSION_MAJOR "0")
set(CPACK_PACKAGE_VERSION_MINOR "9")
set(CPACK_PACKAGE_VERSION_PATCH "14.1${version_suffix}")

#forbid in-tree building
#IF (${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})
#	MESSAGE(STATUS "Please do an out-of-tree build:")
#	MESSAGE(STATUS "rm CMakeCache.txt; mkdir build; cd build; cmake ..; make")
#	MESSAGE(FATAL_ERROR "In-tree-build detected!")
#ENDIF (${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})

#set some safe values
IF(NOT WITH_SERVER)
    SET(WITH_SERVER 0)
ENDIF(NOT WITH_SERVER)
IF(NOT BUILD_ENGINE_LIBRARY)
    SET(BUILD_ENGINE_LIBRARY 0)
ENDIF(NOT BUILD_ENGINE_LIBRARY)


if(APPLE)
    set(CMAKE_FIND_FRAMEWORK "FIRST")

    #paths for creating the bundle
    set(bundle_name Hedgewars.app)
    set(CMAKE_INSTALL_PREFIX ${bundle_name}/Contents/MacOS/)
    set(DATA_INSTALL_DIR "../Resources/")
    set(target_dir ".")

    #what system are we building for
    set(minimum_macosx $ENV{MACOSX_DEPLOYMENT_TARGET})

    #detect on which system are we
    EXEC_PROGRAM("/usr/bin/sw_vers" OUTPUT_VARIABLE MACOSX_VERSION_TMP)
    STRING(REGEX MATCH "[0-9]+\\.[0-9]+\\.[0-9]+" MACOSX_VERSION_TMP "${MACOSX_VERSION_TMP}")
    STRING(REGEX REPLACE "([0-9]+.[0-9]+).[0-9]+" "\\1" current_macosx_version ${MACOSX_VERSION_TMP})

    if(NOT minimum_macosx)
        #if nothing is set, we deploy only for the current system
        set(minimum_macosx ${current_macosx_version})
    endif()

    if (minimum_macosx LESS "10.4")
        set(FATAL "Hedgewars is not supported for pre-10.4 systems")
    endif()

    set(CMAKE_OSX_ARCHITECTURES "i386;ppc7400")


    #create universal binaries only when it's time to bundle the application, also build server
    IF(BUNDLE)
        set(WITH_SERVER true)
        if(NOT minimum_macosx MATCHES "10.6")
            set(CMAKE_C_COMPILER "gcc-4.0")
            set(CMAKE_CXX_COMPILER "g++-4.0")
        else()
            if(current_macosx_version MATCHES "10.6")
                set(CMAKE_OSX_ARCHITECTURES "x86_64")
            endif()
        endif()
    ELSE()
        if(current_macosx_version MATCHES "10.6")
            set(CMAKE_OSX_ARCHITECTURES "x86_64")
        endif()
    ENDIF()

    message(STATUS "Target system: Mac OS X ${minimum_macosx} ${CMAKE_OSX_ARCHITECTURES}")

    if(minimum_macosx MATCHES "10.4")
        set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.4u.sdk/")
        if(current_macosx_version MATCHES "10.4")
            find_package(SDL_mixer REQUIRED)
            set(pascal_compiler_flags_cmn "-k-dylib_file @loader_path/Frameworks/smpeg.framework/Versions/A/smpeg:${SDLMIXER_LIBRARY}/Versions/A/Frameworks/smpeg.framework/Versions/A/smpeg" "-k-dylib_file @loader_path/Frameworks/mikmod.framework/Versions/A/mikmod:${SDLMIXER_LIBRARY}/Versions/A/Frameworks/mikmod.framework/Versions/A/mikmod" ${pascal_compiler_flags_cmn})
            set(CMAKE_C_FLAGS "-dylib_file @loader_path/Frameworks/smpeg.framework/Versions/A/smpeg:${SDLMIXER_LIBRARY}/Versions/A/Frameworks/smpeg.framework/Versions/A/smpeg -dylib_file @loader_path/Frameworks/mikmod.framework/Versions/A/mikmod:${SDLMIXER_LIBRARY}/Versions/A/Frameworks/mikmod.framework/Versions/A/mikmod")
        endif()
    else()
        set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX${minimum_macosx}.sdk/")
    endif()

    #1.set deployment target; 2.link with libsdlmain.a (when building an executable); 3.link with liblua.a (which requires readline)
    set(pascal_compiler_flags_cmn "-k-macosx_version_min" "-k${minimum_macosx}" "-XR${CMAKE_OSX_SYSROOT}" ${pascal_compiler_flags_cmn})
    if(NOT BUILD_ENGINE_LIBRARY)
        set(pascal_compiler_flags_cmn "-k${CMAKE_BINARY_DIR}/bin/libSDLmain.a" ${pascal_compiler_flags_cmn})
    endif()
    set(pascal_compiler_flags_cmn "-k${CMAKE_BINARY_DIR}/bin/liblua.a" "-k-lreadline" ${pascal_compiler_flags_cmn})
else(APPLE)
    set(target_dir "bin")
endif(APPLE)


#this snippet sets "Release" mode by default
#IF (NOT CMAKE_BUILD_TYPE)
#	SET(CMAKE_BUILD_TYPE "Release")
#ENDIF (NOT CMAKE_BUILD_TYPE)
if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE RELEASE CACHE STRING "Choose the type of build, options are: None Debug Release." FORCE)
endif (NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES RELEASE OR CMAKE_BUILD_TYPE MATCHES "Release")
    message(STATUS "Building Release")
    set(Optz true)
else()
    message(STATUS "Building Debug")
    #set(CMAKE_VERBOSE_MAKEFILE true)
    set(Optz false)
endif()


#set default flags values for all the project
set(CMAKE_C_FLAGS "-pipe ${CMAKE_C_FLAGS}")
set(CMAKE_C_FLAGS_RELEASE "-w -O2 -fomit-frame-pointer ${CMAKE_C_FLAGS_RELEASE}")
set(CMAKE_C_FLAGS_DEBUG "-Wall -O0 -g -DDEBUG ${CMAKE_C_FLAGS_DEBUG}")
set(CMAKE_CXX_FLAGS ${CMAKE_C_FLAGS})
set(CMAKE_CXX_FLAGS_RELEASE ${CMAKE_C_FLAGS_RELEASE})
set(CMAKE_CXX_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})

set(pascal_compiler_flags_cmn "-B" "-FE../bin" "-Cs2000000" "-vewn" ${pascal_compiler_flags_cmn})

if(Optz)
#	set(pascal_compiler_flags_cmn "-O3" "-OpPENTIUM4" "-CfSSE3" "-Xs" "-Si" ${pascal_compiler_flags_cmn})
    set(pascal_compiler_flags_cmn "-O2" "-Xs" "-Si" ${pascal_compiler_flags_cmn})
    set(haskell_compiler_flags_cmn "-O2" "-w")
else(Optz)
    set(pascal_compiler_flags_cmn "-O-" "-g" "-gh" "-gl" "-dDEBUGFILE" ${pascal_compiler_flags_cmn})
    set(haskell_compiler_flags_cmn "-Wall" "-debug" "-dcore-lint")
endif(Optz)


if(DEFINED DATA_INSTALL_DIR)
    set(SHAREPATH ${DATA_INSTALL_DIR}/hedgewars/)
else()
    set(SHAREPATH share/hedgewars/)
endif()
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)

set(HEDGEWARS_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(HEDGEWARS_PROTO_VER 35)

if(WITH_SERVER)
    message(STATUS "Server is going to be built! Make sure you have GHC installed")
    set(HAVE_NETSERVER true)
    add_subdirectory(gameServer)
else(WITH_SERVER)
    set(HAVE_NETSERVER false)
endif(WITH_SERVER)

add_subdirectory(misc/liblua)
add_subdirectory(hedgewars)
#add_subdirectory(misc/libopenalbridge)
if(NOT BUILD_ENGINE_LIBRARY)
    add_subdirectory(bin)
    add_subdirectory(QTfrontend)
    add_subdirectory(share)
    add_subdirectory(tools)
endif()

# CPack vars

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Hedgewars, a free turn-based strategy")
set(CPACK_PACKAGE_VENDOR "Hedgewars Project")
set(CPACK_PACKAGE_FILE_NAME "hedgewars-${HEDGEWARS_VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "hedgewars-src-${HEDGEWARS_VERSION}")
set(CPACK_SOURCE_GENERATOR "TBZ2")
set(CPACK_PACKAGE_EXECUTABLES "hedgewars" "hedgewars")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "Hedgewars ${HEDGEWARS_VERSION}")

if(WIN32 AND NOT UNIX)
    set(CPACK_NSIS_DISPLAY_NAME "Hedgewars")
    set(CPACK_NSIS_HELP_LINK "http://www.hedgewars.org/")
    set(CPACK_NSIS_URL_INFO_ABOUT "http://www.hedgewars.org/")
    set(CPACK_NSIS_CONTACT "unC0Rr@gmail.com")
    set(CPACK_NSIS_MODIFY_PATH OFF)
    set(CPACK_GENERATOR "ZIP;NSIS")
    set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "hedgewars")
else(WIN32 AND NOT UNIX)
    set(CPACK_STRIP_FILES "bin/hedgewars;bin/hwengine")
endif(WIN32 AND NOT UNIX)

set(CPACK_SOURCE_IGNORE_FILES
    "~"
    "\\\\.hg"
    "\\\\.svn"
    "\\\\.exe$"
    "\\\\.a$"
    "\\\\.dll$"
    "\\\\.xcf$"
    "\\\\.cxx$"
    "\\\\.db$"
    "\\\\.dof$"
    "\\\\.layout$"
    "\\\\.zip$"
    "\\\\.gz$"
    "\\\\.bz2$"
    "\\\\.tmp$"
    "\\\\.core$"
    "\\\\.sh$"
    "\\\\.sifz$"
    "\\\\.svg$"
    "\\\\.svgz$"
    "\\\\.ppu$"
    "\\\\.psd$"
    "\\\\.o$"
    "Makefile"
    "Doxyfile"
    "CMakeFiles"
    "debug"
    "release$"
    "Debug$"
    "Release$"
    "proto.inc$"
    "hwconsts.cpp$"
    "playlist.inc$"
    "CPack"
    "cmake_install.cmake$"
    "config.inc$"
    "hwengine.desktop$"
#   "^${CMAKE_CURRENT_SOURCE_DIR}/misc/libopenalbridge"
    "^${CMAKE_CURRENT_SOURCE_DIR}/project_files/HedgewarsMobile/"
    "^${CMAKE_CURRENT_SOURCE_DIR}/bin/[a-z]"
    "^${CMAKE_CURRENT_SOURCE_DIR}/tools/templates"
    "^${CMAKE_CURRENT_SOURCE_DIR}/doc"
    "^${CMAKE_CURRENT_SOURCE_DIR}/templates"
    "^${CMAKE_CURRENT_SOURCE_DIR}/Graphics"
    "^${CMAKE_CURRENT_SOURCE_DIR}/realtest"
    "^${CMAKE_CURRENT_SOURCE_DIR}/tmp"
    "^${CMAKE_CURRENT_SOURCE_DIR}/utils"
    "^${CMAKE_CURRENT_SOURCE_DIR}/share/hedgewars/Data/Maps/test"
    "^${CMAKE_CURRENT_SOURCE_DIR}/share/hedgewars/Data/Themes/ethereal"
    "^${CMAKE_CURRENT_SOURCE_DIR}/install_manifest.txt"
    "^${CMAKE_CURRENT_SOURCE_DIR}/CMakeCache.txt"
    "^${CMAKE_CURRENT_SOURCE_DIR}/hedgewars\\\\."
)

include(CPack)

=== QTfrontend/CMakeLists.txt ===
# Configure for Qt4
set(QT_MIN_VERSION "4.5.0")

set(QT_USE_QTCORE TRUE)
set(QT_USE_QTGUI TRUE)
set(QT_USE_QTNETWORK TRUE)
set(QT_USE_QTSVG FALSE)
set(QT_USE_QTXML FALSE)
set(QT_USE_QTOPENGL FALSE)
set(QT_USE_QTMAIN TRUE)

find_package(Qt4 REQUIRED)
include(${QT_USE_FILE})

#find_package(QCA2 REQUIRED)
#include_directories(${QCA2_INCLUDE_DIR})

# Configure for SDL
find_package(SDL REQUIRED)
find_package(SDL_mixer REQUIRED)

include_directories(.)
include_directories(${SDL_INCLUDE_DIR})
include_directories(${SDLMIXER_INCLUDE_DIR})
if(UNIX)
	# HACK: in freebsd cannot find iconv.h included via SDL.h
	include_directories("/usr/local/include")
endif(UNIX)


if(WIN32 AND NOT UNIX)
	set(HEDGEWARS_BINDIR ".")
	set(HEDGEWARS_DATADIR "../share/")
        add_definitions(-DUSE_XFIRE)
else()
	set(HEDGEWARS_BINDIR ${CMAKE_INSTALL_PREFIX})
	if(DEFINED DATA_INSTALL_DIR)
		set(HEDGEWARS_DATADIR ${DATA_INSTALL_DIR})
	else()
		set(HEDGEWARS_DATADIR ${CMAKE_INSTALL_PREFIX}/share/)
	endif()
endif()


configure_file(${CMAKE_CURRENT_SOURCE_DIR}/hwconsts.cpp.in ${CMAKE_CURRENT_BINARY_DIR}/hwconsts.cpp)

set(	hwfr_src
	game.cpp
	main.cpp
	hwform.cpp
	team.cpp
	namegen.cpp
	teamselect.cpp
	teamselhelper.cpp
	frameTeam.cpp
	vertScrollArea.cpp
	gameuiconfig.cpp
	ui_hwform.cpp
	gamecfgwidget.cpp
	pages.cpp
	SquareLabel.cpp
	hats.cpp
	hedgehogerWidget.cpp
	hwmap.cpp
	mapContainer.cpp
	tcpBase.cpp
	about.cpp
	proto.cpp
	fpsedit.cpp
	netserver.cpp
	newnetclient.cpp
	netudpserver.cpp
	netudpwidget.cpp
	netregister.cpp
	netserverslist.cpp
	chatwidget.cpp
	binds.cpp
	SDLs.cpp
	playrecordpage.cpp
	${CMAKE_CURRENT_BINARY_DIR}/hwconsts.cpp
	selectWeapon.cpp
	itemNum.cpp
	input_ip.cpp
	igbox.cpp
	weaponItem.cpp
	statsPage.cpp
	misc.cpp
	ammoSchemeModel.cpp
	togglebutton.cpp
	bgwidget.cpp
	achievements.cpp
	)

#xfire integration
if(WIN32)
	set(hwfr_src ${hwfr_src} xfire.cpp ../misc/xfire/xfiregameclient.cpp)
endif(WIN32)

if(MINGW)
	# resource compilation for mingw
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hedgewars_rc.o
	COMMAND windres -I ${CMAKE_CURRENT_SOURCE_DIR}
	-i ${CMAKE_CURRENT_SOURCE_DIR}/hedgewars.rc
	-o ${CMAKE_CURRENT_BINARY_DIR}/hedgewars_rc.o)
	set(hwfr_src ${hwfr_src} ${CMAKE_CURRENT_BINARY_DIR}/hedgewars_rc.o)
else(MINGW)
	set(hwfr_src ${hwfr_src} hedgewars.rc)
endif(MINGW)

set(	hwfr_moc_hdrs
	game.h
	hats.h
	hwform.h
	teamselect.h
	teamselhelper.h
	frameTeam.h
	vertScrollArea.h
	gameuiconfig.h
	gamecfgwidget.h
	pages.h
	SquareLabel.h
	hedgehogerWidget.h
	hwmap.h
	mapContainer.h
	tcpBase.h
	about.h
	proto.h
	fpsedit.h
	netserver.h
	newnetclient.h
	netudpserver.h
	netudpwidget.h
	netregister.h
	netserverslist.h
	chatwidget.h
	SDLs.h
	playrecordpage.h
	selectWeapon.h
	itemNum.h
	input_ip.h
	igbox.h
	weaponItem.h
	statsPage.h
	misc.h
	ammoSchemeModel.h
	togglebutton.h
	bgwidget.h
	)

set(	hwfr_hdrs
	binds.h
	ui_hwform.h
	predefteams.h
	KB.h
	hwconsts.h
	)

set(hwfr_rez hedgewars.qrc)

qt4_add_resources(hwfr_rez_src ${hwfr_rez})

qt4_wrap_cpp(hwfr_moc_srcs ${hwfr_moc_hdrs})


if(APPLE)
	set(hwfr_src ${hwfr_src} InstallController.cpp CocoaInitializer.mm M3Panel.mm M3InstallController.m NSWorkspace_RBAdditions.m)
	set(HW_LINK_LIBS IOKit)

	find_package(Sparkle)
	if(SPARKLE_FOUND)
                add_definitions(-DSPARKLE_ENABLED)
		set(hwfr_src ${hwfr_src} AutoUpdater.cpp SparkleAutoUpdater.mm)
                set(HW_LINK_LIBS ${SPARKLE_LIBRARY} ${HW_LINK_LIBS})
	endif()
endif()


add_executable(hedgewars WIN32
	${hwfr_src}
	${hwfr_moc_srcs}
	${hwfr_hdrs}
	${hwfr_rez_src}
	)


set(	HW_LINK_LIBS
	${QT_LIBRARIES}
	${SDL_LIBRARY}
	${SDLMIXER_LIBRARY}
	${HW_LINK_LIBS}
	)

if(WIN32 AND NOT UNIX)
	if(NOT SDL_LIBRARY)
		set(HW_LINK_LIBS ${HW_LINK_LIBS} SDL)
	endif()

	set(	HW_LINK_LIBS
		${HW_LINK_LIBS}
		ole32
		oleaut32
		winspool
		uuid
		)
endif()


target_link_libraries(hedgewars	${HW_LINK_LIBS})


install(PROGRAMS "${EXECUTABLE_OUTPUT_PATH}/hedgewars${CMAKE_EXECUTABLE_SUFFIX}" DESTINATION ${target_dir})

=== bin/CMakeLists.txt ===
if(WIN32 AND NOT UNIX)
	file(GLOB DLLs *.dll)
	
	install(FILES
		${DLLs}
		DESTINATION bin)
endif(WIN32 AND NOT UNIX)

=== hedgewars/CMakeLists.txt ===
find_package(SDL)
find_package(SDL_image)
find_package(SDL_net)
find_package(SDL_ttf)
find_package(SDL_mixer)
find_package(Lua)

configure_file(${hedgewars_SOURCE_DIR}/hedgewars/config.inc.in ${CMAKE_CURRENT_BINARY_DIR}/config.inc)

#find which version of SDL_image and SDL_mixer we have (for IMG_Init and Mix_Init)
#if the headers are not installed, the newer apis won't be activated
find_file(sdlmixer_h SDL_mixer.h ${SDLMIXER_INCLUDE_DIR})
if(sdlmixer_h)
	file(STRINGS ${sdlmixer_h} sdlmixer_version_tmp REGEX "SDL_MIXER_PATCHLEVEL[\t' ']+[0-9]+")
	string(REGEX MATCH ".([0-9]+)" sdlmixer_version "${sdlmixer_version_tmp}")

	if(sdlmixer_version GREATER 9)
		message(STATUS "Enabling enhanced SDL_Mixer calls")
		set(pascal_compiler_flags_cmn "-dSDL_MIXER_NEWER" ${pascal_compiler_flags_cmn})
	endif()
endif()

find_file(sdlimage_h SDL_image.h ${SDLIMAGE_INCLUDE_DIR})
if(sdlimage_h)
	file(STRINGS ${sdlimage_h} sdlimage_version_tmp REGEX "SDL_IMAGE_PATCHLEVEL[\t' ']+[0-9]+")
	string(REGEX MATCH ".([0-9]+)" sdlimage_version "${sdlimage_version_tmp}")

	if(sdlimage_version GREATER 7)
		message(STATUS "Enabling enhanced SDL_Image calls")
		set(pascal_compiler_flags_cmn "-dSDL_IMAGE_NEWER" ${pascal_compiler_flags_cmn})
	endif()
endif()

#SOURCE AND PROGRAMS SECTION
set(fpc_tryexe fpc)
set(hwengine_project ${hedgewars_SOURCE_DIR}/hedgewars/hwengine.pas)

set(engine_sources
	${hwengine_project}
	SDLh.pas
	uAI.pas
	uAIActions.pas
	uAIAmmoTests.pas
	uAIMisc.pas
	uAmmos.pas
	uChat.pas
	uCollisions.pas
	uConsole.pas
	uConsts.pas
	uFloat.pas
	uGame.pas
	uGears.pas
	uIO.pas
	uKeys.pas
	uLand.pas
	uLandGraphics.pas
	uLandObjects.pas
	uLandTemplates.pas
	uLandTexture.pas
	uLocale.pas
	uMisc.pas
	uMobile.pas
	uRandom.pas
	uScript.pas
	adler32.pas
	uSound.pas
	uStats.pas
	uStore.pas
	uTeams.pas
	uVisualGears.pas
	uWorld.pas
	CCHandlers.inc
	GSHandlers.inc
	VGSHandlers.inc
	GearDrawing.inc
	HHHandlers.inc
	SinTable.inc
	ArgParsers.inc
	options.inc
	${CMAKE_CURRENT_BINARY_DIR}/config.inc
	)

if(BUILD_ENGINE_LIBRARY)
	message(STATUS "Engine will be built as library (experimental)")
	set(hwengine_project ${hedgewars_SOURCE_DIR}/hedgewars/hwLibrary.pas)
	set(engine_sources ${hwengine_project} PascalExports.pas ${engine_sources})
	set(pascal_compiler_flags_cmn "-dHWLIBRARY" "-k-no_order_inits" "-fPIC" ${pascal_compiler_flags_cmn})
endif(BUILD_ENGINE_LIBRARY)


find_program(fpc_executable ${fpc_tryexe})

if(fpc_executable)
	 exec_program(${fpc_executable} ARGS "-iV" OUTPUT_VARIABLE fpc_output)
endif(fpc_executable)

set(noexecstack_flags "-k-z" "-knoexecstack")
file(WRITE ${EXECUTABLE_OUTPUT_PATH}/checkstack.pas "begin end.")

exec_program(${fpc_executable} ${EXECUTABLE_OUTPUT_PATH}
	ARGS ${noexecstack_flags} checkstack.pas
	OUTPUT_VARIABLE noout
	RETURN_VALUE testnoexecstack
	)

if(${testnoexecstack})
	set (noexecstack_flags "")
endif(${testnoexecstack})


if(APPLE)
	string(REGEX MATCH "[pP][pP][cC]+" powerpc_build "${CMAKE_OSX_ARCHITECTURES}")
	string(REGEX MATCH "[iI]386+" i386_build "${CMAKE_OSX_ARCHITECTURES}")
	string(REGEX MATCH "[xX]86_64+" x86_64_build "${CMAKE_OSX_ARCHITECTURES}")

	if(powerpc_build)
		set(powerpc_build "powerpc")
	endif()
endif(APPLE)


#PASCAL DETECTION SECTION
string(REGEX MATCH "[0-9]+\\.[0-9]+\\.[0-9]+" fpc_version "${fpc_output}")

if(fpc_version)
	string(REGEX REPLACE "([0-9]+)\\.[0-9]+\\.[0-9]+" "\\1" fpc_vers_major "${fpc_version}")
	string(REGEX REPLACE "[0-9]+\\.([0-9]+)\\.[0-9]+" "\\1" fpc_vers_minor "${fpc_version}")
	string(REGEX REPLACE "[0-9]+\\.[0-9]+\\.([0-9]+)" "\\1" fpc_vers_patch "${fpc_version}")
	message(STATUS "Freepascal version detected: ${fpc_vers_major}.${fpc_vers_minor}")
	math(EXPR fpc_ver "${fpc_vers_major}*10000 + ${fpc_vers_minor}*100 + ${fpc_vers_patch}")

	if(fpc_ver LESS "020200")
		message(FATAL_ERROR "Minimum required version of FreePascal is 2.2.0")
	elseif(APPLE AND x86_64_build AND fpc_ver LESS "020400")
		message(FATAL_ERROR "Minimum required version of FreePascal is 2.4.0 for building 64 bit applications!")
	endif()
else()
	message(FATAL_ERROR "No Pascal compiler found!")
endif()

set(pascal_compiler ${fpc_executable})
set(pascal_compiler_flags ${noexecstack_flags} ${pascal_compiler_flags_cmn} ${hwengine_project})


#DEPENDECIES AND EXECUTABLES SECTION
IF(NOT APPLE OR BUILD_ENGINE_LIBRARY)
	#here is the command for standard executables or for shared library
	add_custom_command(OUTPUT "${EXECUTABLE_OUTPUT_PATH}/hwengine${CMAKE_EXECUTABLE_SUFFIX}"
		COMMAND "${pascal_compiler}"
		ARGS ${pascal_compiler_flags}
		MAIN_DEPENDENCY ${hwengine_project}
		DEPENDS ${engine_sources}
		)
ELSE()
	#let's build sdlmain, which is absent from the framework
	find_package(SDL REQUIRED)

	set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
	include_directories(${SDL_INCLUDE_DIR})

	add_library (SDLmain STATIC SDLMain.m)


	#these are the dependencies for building a universal binary on Mac OS X
	foreach (build_arch ${powerpc_build} ${i386_build} ${x86_64_build})
		set(lipo_args_list "${EXECUTABLE_OUTPUT_PATH}/hwengine.${build_arch}" ${lipo_args_list})
		add_custom_command(OUTPUT "${EXECUTABLE_OUTPUT_PATH}/hwengine.${build_arch}"
			COMMAND "${pascal_compiler}"
			ARGS ${pascal_compiler_flags} -ohwengine.${build_arch} -P${build_arch}
			MAIN_DEPENDENCY ${hwengine_project}
			DEPENDS ${engine_sources} SDLmain lua
			)
		add_custom_target(hwengine.${build_arch} ALL DEPENDS "${EXECUTABLE_OUTPUT_PATH}/hwengine.${build_arch}")
	endforeach()

	add_custom_command(OUTPUT "${EXECUTABLE_OUTPUT_PATH}/hwengine"
		COMMAND "lipo"
		ARGS ${lipo_args_list} -create -output ${EXECUTABLE_OUTPUT_PATH}/hwengine
		DEPENDS ${lipo_args_list}
		)
ENDIF()


add_custom_target(hwengine ALL DEPENDS "${EXECUTABLE_OUTPUT_PATH}/hwengine${CMAKE_EXECUTABLE_SUFFIX}")

install(PROGRAMS "${EXECUTABLE_OUTPUT_PATH}/hwengine${CMAKE_EXECUTABLE_SUFFIX}" DESTINATION ${target_dir})

=== share/CMakeLists.txt ===
add_subdirectory(hedgewars)

IF(APPLE)
	configure_file(${hedgewars_SOURCE_DIR}/share/Info.plist.in 
		${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
	install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/Info.plist"
		DESTINATION ../)
	install(PROGRAMS "${hedgewars_SOURCE_DIR}/misc/Icon.icns"
		DESTINATION ../Resources/)
	install(PROGRAMS "${hedgewars_SOURCE_DIR}/misc/dsa_pub.pem"
		DESTINATION ../Resources/)
ENDIF(APPLE)

=== tools/CMakeLists.txt ===
if (NOT APPLE)
	CONFIGURE_FILE(
		"${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
		"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
		IMMEDIATE @ONLY)

	ADD_CUSTOM_TARGET(uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif()

if (APPLE AND BUNDLE)

	find_package(Qt4 REQUIRED)
	find_package(SDL REQUIRED)
	find_package(SDL_image REQUIRED)
	find_package(SDL_net REQUIRED)
	find_package(SDL_ttf REQUIRED)
	find_package(SDL_mixer REQUIRED)
	find_package(OGGVORBIS REQUIRED)
	find_package(SPARKLE)
	find_program(macdeployqt_EXE NAMES macdeployqt macdeployqt-mac)

	if(NOT macdeployqt_EXE)
		message(FATAL_ERROR "The utility macdeployqt is required to create the bundle!")
	endif()

	#dummy target, we're interested in the postscript file
	add_custom_target(bundle)

	set_target_properties(bundle PROPERTIES POST_INSTALL_SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/CreateMacBundle.cmake)

	set(frameworks_dir ${bundle_name}/Contents/Frameworks/)

	string(REGEX REPLACE "(.*);-.*" "\\1" sdl_dir "${SDL_LIBRARY}")

	if(SPARKLE_FOUND)
		set(SPARKLE_FOUND 1)
	else()
		set(SPARKLE_FOUND 0)
	endif()

	CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/CreateMacBundle.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/CreateMacBundle.cmake)

endif(APPLE AND BUNDLE)

=== misc/liblua/CMakeLists.txt ===
file(GLOB lua_src *.c *.h)
set(LIBRARY_OUTPUT_PATH ${EXECUTABLE_OUTPUT_PATH})

IF(APPLE)
#	set(CMAKE_OSX_ARCHITECTURES "x86_64;i386;ppc7400")

	set(build_type STATIC)
	add_definitions(-DLUA_USE_LINUX)
	add_library (lua ${build_type} ${lua_src})
ENDIF(APPLE)

IF(WIN32)
	set(build_type SHARED)
	add_definitions(-DLUA_BUILD_AS_DLL)
	add_library (lua ${build_type} ${lua_src})
ENDIF(WIN32)

if(WIN32)
	SET_TARGET_PROPERTIES(lua PROPERTIES PREFIX "")
	install(TARGETS lua RUNTIME DESTINATION ${target_dir})
endif(WIN32)

=== share/hedgewars/Data/CMakeLists.txt ===
foreach(dir "Fonts" "Forts" "Graphics" "Locale" "Maps" "Music" "Sounds" "Themes" "Missions" "Names" "misc")
  add_subdirectory(${dir})
endforeach(dir)

=== share/hedgewars/Data/Fonts/CMakeLists.txt ===
install(FILES
	DejaVuSans-Bold.ttf
    wqy-zenhei.ttc
	DESTINATION ${SHAREPATH}Data/Fonts)

=== share/hedgewars/Data/Forts/CMakeLists.txt ===
file(GLOB FortSprites *L.png *R.png) 

install(FILES
	${FortSprites}
	DESTINATION ${SHAREPATH}Data/Forts)

=== share/hedgewars/Data/Locale/CMakeLists.txt ===
file(GLOB txttrans2 ??.txt)
file(GLOB txttrans5 ?????.txt)
file(GLOB tsfiles *.ts)

QT4_ADD_TRANSLATION(QM ${tsfiles})

add_custom_target (release-translation ALL 
		DEPENDS ${QM}
		COMMENT "Compiling ts files"
)

install(FILES
	${txttrans2}
	${txttrans5}
	${QM}
	DESTINATION ${SHAREPATH}Data/Locale
)

=== share/hedgewars/Data/Maps/CMakeLists.txt ===
foreach(dir
	Bamboo
	BambooPlinko
	Basketball
	Bath
	Battlefield
	Blox
	Bubbleflow
	Cake
	Castle
	Cave
	Cheese
	Cogs
	CrazyMission
	EarthRise
	Eyes
	Hammock
	HedgeFortress
	Hedgelove
	Hedgewars
	Hogville
	Hydrant
	Islands
	Knockball
	Lonely_Island
	Mushrooms
	Octorama
	PirateFlag
	Plane
	Ropes
	Ruler
	Sheep
	ShoppaKing
	Sticks
	Trash
	Tree
	TrophyRace
	)

add_subdirectory(${dir})
endforeach(dir)

=== debian/changelog ===
hedgewars (0.9.14.1-1) unstable; urgency=low

  * New upstream version.
   + New audio tracks
   + New forts: EvilChicken, Tank
   + New game modes: AI Survival Mode, Per Hedgehog Ammo,
     Reset Health, Reset Weapons, Unlimited Attacks
   + New grave: ring
   + Over 30 new hats
   + New themes: Art, Brick, Jungle, Stage
   + New maps: ShoppaKing, Sticks, TrophyRace (Mission)
   + New utilities: Portal Gun, Resurrector
   + New weapons: Flamethrower, Hammer, Old Limburger,
     Piano Strike, Sticky Mines
   + Weapons' projectiles will how be launched from their
     barrels instead of the hog's center
   + Flying Saucers may be used for moving below the water surface
   + New default game schemes: Clean Slate, Fort Mode, Timeless,
     Thinking with Portals, King Mode
   + New default weapon set: Clean Slate, Thinking with Portals
   + Bomb clusters/Melon parts inherit some of the original bomb's speed
   + Extended game statistics
   + Improved health bar updating
   + Hogs that blow themselves up will use triggers in they team color
   + Settings allow better control over the level of details/effects
   + Improved Lua support
   + On empty ammo switch to no weapon rather than the first available
     one (to avoid shooting by accident)
   + Display of hints in the frontend
   + Some improvements of existing Themes of Maps
   + Land destruction effects added
   + Improved fire effects
   + Improved Melon explosion effects
   + Online game lobby now features game filters
   + Other Frontend enhancements
   + Additional sounds
   + Show special game rules in Esc screen
   + Updated translation
   + Speed optimizations
   + Hedgewars will now use a sub directory of "My Documents"
     like other games instead of "%userprofile%/.hedgewars" under Windows
   + Added support for graphics cards/drivers that have a 512x512
     pixel textures limit
   + Team colors are more distinguishable from each other now
   * Fixed bug that allowed charging a weapon while on rope,
     leading to frozen timer
   * Various bug fixes
  * Switched to 3.0 source format.
  * Switched to cdbs build system.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 14 Nov 2010 22:45:48 +0300

hedgewars (0.9.13-1) unstable; urgency=low

  * New upstream version, closes: #576370
    * many bug fixes
    * speed optimisations
    * many new hats, hats visible while using rope and blowtorch
    * Exploding barrels
    * AI uses new weapons, aware of fire, can fight in artillery mode
    * New options in ammo editing - crate probability, delays
    * option of semi-opaque hog name tags to avoid fail when
      land is hidden by name
    * new British voicepack
    * notification sound when people join your room
    * translation updates
    * contextual help when using weapons menu
    * 3d effect for waves
    * fade effect when starting/stopping game
    * new game modes - place hedgehog, king mode, randomise starts,
      allies share ammo, disable girders
    * shift + direction to turn without moving
    * view ammo menu when not your turn
    * new font for CJK text and better CJK detection
    * dud mines
    * hat reservation for donators (hats should be released to public
      in 6 months or so)
    * team flags
    * visual effects: dust on fall impact, smoke, shotgun shells,
      blink team name on start of turn, hogs pulling weapons out,
      falling flakes kicked by explosion and more
    * hogs react to throwing grenades / dynamite and when near them
    * graphic of crate contents when picking up weapon/utility
    * walk sound for hedgehogs
    * UFO changed to homing bee
    * splashes/droplets when things fall in the water
    * 45 degree bounce when throwing grenades
    * new bounce sounds
    * information on game rules when starting game
    * knockball map (scripted map)
    * Birdy weapon and poisoning effect
    * maze generator for new random maps
    * new crazy map template
    * new Olympics, Desert themes, visual updates to many other themes
    * Background texture for land for a 3d effect on explosions
    * frontend able to delete teams
    * ignore/friends lists in frontend
    * alt weapon preview on rope, parachute
    * updated options in frontend: independent toggles for
      frontend/game sound/music, select locale
    * More
    * lua scripting
      Lua scripting allows the easy creation of missions and special maps.
      Examples of this can be seen in the Knockball and Basketball maps,
      that are now scripted

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 05 Apr 2010 10:39:04 +0400

hedgewars (0.9.12-2) unstable; urgency=low

  * fixes 'FTBFS: Error: Illegal parameter: -Nu', closes: #573694,
    thanks for Lucas Nussbaum <lucas@lucas-nussbaum.net>.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 15 Mar 2010 11:03:16 +0300

hedgewars (0.9.12-1) unstable; urgency=low

  * New upstream version.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 18 Oct 2009 22:39:07 +0400

hedgewars (0.9.11-5) unstable; urgency=low

  * Icon for .desktop file has been installed, too, closes: #540235,
    thanks for Andrew SB <a.starr.b@gmail.com>.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 06 Aug 2009 22:38:40 +0400

hedgewars (0.9.11-4) unstable; urgency=low

  * Fixed FTBFS: added absent build-depends.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 05 Aug 2009 12:02:26 +0400

hedgewars (0.9.11-3) unstable; urgency=low

  * Turned on network/server features (server was patched for buildling by
    new haskell-compiler).

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 05 Aug 2009 10:44:23 +0400

hedgewars (0.9.11-2) unstable; urgency=low

  * Added Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
    to uploaders list.
  * debian/copyright has been updated (added section about fonts).

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 07 Jul 2009 15:38:33 +0400

hedgewars (0.9.11-1) unstable; urgency=low

  * New upstream version, closes: #526975, #532851.


=== debian/control ===
Source: hedgewars
Section: games
Priority: extra
Maintainer: Dmitry E. Oboukhov <unera@debian.org>
Uploaders: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Build-Depends: debhelper (>= 7), cmake, cdbs,
 libqt4-dev (>= 4.2), fp-compiler, libsdl1.2-dev, libsdl-ttf2.0-dev,
 libsdl-mixer1.2-dev, libsdl-image1.2-dev, libsdl-net1.2-dev, bzip2,
 fp-units-gfx,
 ghc6, libghc6-stm-dev, libghc6-network-dev, libghc6-utf8-string-dev,
 libghc6-time-dev, libghc6-dataenc-dev, libghc6-hslogger-dev,
 liblua5.1-dev
Standards-Version: 3.9.1
Homepage: http://hedgewars.org
VCS-Browser: http://git.debian.org/?p=collab-maint/hedgewars.git;a=summary
VCS-Git: git://git.debian.org/collab-maint/hedgewars.git

Package: hedgewars
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 ttf-dejavu,
 hedgewars-data (>= ${source:Upstream-Version})
Description: Worms style game
 Each player controls a team of several hedgehogs. During the
 course of the game, players take turns with one of their
 hedgehogs. They then use whatever tools and weapons are
 available to attack and kill the opponents' hedgehogs, thereby
 winning the game. Hedgehogs may move around the terrain in a
 variety of ways, normally by walking and jumping but also by
 using particular tools such as the "Rope" or "Parachute", to
 move to otherwise inaccessible areas. Each turn is time-limited
 to ensure that players do not hold up the game with excessive
 thinking or moving.
 .
 A large variety of tools and weapons are available for players
 during the game: Grenade, Cluster Bomb, Bazooka, UFO, Shotgun,
 Desert Eagle, Fire Punch, Baseball Bat, Dynamite, Mine, Rope,
 Pneumatic pick, Parachute. Most weapons, when used, cause
 explosions that deform the terrain, removing circular chunks.
 The landscape is an island floating on a body of water, or a
 restricted cave with water at the bottom. A hedgehog dies when
 it enters the water (either by falling off the island, or
 through a hole in the bottom of it), it is thrown off either
 side of the arena or when its health is reduced, typically from
 contact with explosions, to zero (the damage dealt to the
 attacked hedgehog or hedgehogs after a player's or CPU turn is
 shown only when all movement on the battlefield has ceased).

Package: hedgewars-data
Conflicts: hedgewars (<= 0.8.1-10)
Replaces: hedgewars (<= 0.8.1-10)
Architecture: all
Depends: ${misc:Depends}
Recommends: hedgewars
Description: Data files for hedgewars
 This package contains data files (images, sounds, levels data) 
 for the hedgewars package.

=== debian/rules ===
#!/usr/bin/make -f

DEB_CMAKE_INSTALL_PREFIX := /usr/lib/hedgewars
DEB_CMAKE_EXTRA_FLAGS      := -DWITH_SERVER=1 \
	-DDATA_INSTALL_DIR=/usr/share/games

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
